# Ensure IPSec Gateway

Ensures that the IPSecGateway with the provided ID is created or modified. The full IPSecGateway needs to be provided to ensure (either update or create) the IPSecGateway. Non present data will only be filled with defaults or left empty, but not take previous values into consideration.

To ensure that the IPSecGateway with the provided ID is created or modified, perform `PUT` request.

{% hint style="info" %}
**Note:** If IPSecGateway for a given `gatewayId` does not exist, a new one is created instead.
{% endhint %}

## Endpoint

Use the following endpoint to ensure IPSecGateway is created or modified: `https://vpn.de-fra.ionos.com/ipsecgateways/{gatewayId}`.

## Request

{% hint style="info" %}
**Note:** The following request contains a sample `gatewayId`. Replace them with the `gatewayId` value whose information you want to update.
{% endhint %}

```bash
curl --location \
--request PUT 'https://vpn.de-fra.ionos.com/ipssecgateways/66a114c7-2ddd-5119-9ddf-5a789f5a5a44' \
--header 'Authorization: Bearer eyJ0eXAiOiJKV1QiLCJraWQiO' \
--header 'Content-Type: application/json' \
--data-raw '{
  "id": "66a114c7-2ddd-5119-9ddf-5a789f5a5a44",
  "metadata": {},
  "properties": {
    "name": "My Company Gateway",
    "description": "This gateway connects site A to VDC X.",
    "gatewayIP": "81.173.1.2",
    "connections": [
      {
        "datacenterId": "5a029f4a-72e5-11ec-90d6-0242ac120003",
        "lanId": "2",
        "ipv4CIDR": "192.168.1.100/24",
        "ipv6CIDR": "2001:0db8:85a3::/24"
      }
    ],
    "version": "IKEv2"
  }
}'

```

{% tabs %}
{% tab title="Path Parameters" %}
Below is the list of mandatory path parameters for updating an IPSecGateway:

| Path Parameters | Type   | Description                        | Example                                |
| --------------- | ------ | ---------------------------------- | -------------------------------------- |
| `gatewayId`     | string | The ID (UUID) of the IPSecGateway. | `66a114c7-2ddd-5119-9ddf-5a789f5a5a44` |
| {% endtab %}    |        |                                    |                                        |

{% tab title="Request Body Parameters" %}
Below is the list of mandatory body parameters for updating an IPSecGateway:

| Body Parameters          | Required | Type   | Description                                                              | Example                                                                                                                                           |
| ------------------------ | -------- | ------ | ------------------------------------------------------------------------ | ------------------------------------------------------------------------------------------------------------------------------------------------- |
| `id`                     | yes      | string | The ID (UUID) of the IPSec Gateway.                                      | `66a114c7-2ddd-5119-9ddf-5a789f5a5a44`                                                                                                            |
| `metadata`               | no       | object | Metadata                                                                 | `{}`                                                                                                                                              |
| `properties`             | yes      | object | Properties with all data needed to update the IPSec Gateway.             |                                                                                                                                                   |
| `properties.name`        | yes      | string | The human readable name of your IPSec Gateway.                           | `My Company IPSec Gateway`                                                                                                                        |
| `properties.description` | no       | string | Human readable description of the IPSec Gateway.                         | `This gateway connects site A to VDC X.`                                                                                                          |
| `properties.gatewayIP`   | yes      | string | Public IP address to be assigned to the gateway.                         | `81.173.1.2`                                                                                                                                      |
| `properties.connections` | yes      | array  | The network connection for your gateway.                                 | `[ { "datacenterId": "5a029f4a-72e5-11ec-90d6-0242ac120003", "lanId": "2", "ipv4CIDR": "192.168.1.100/24", "ipv6CIDR": "2001:0db8:85a3::/24" } ]` |
| `properties.version`     | no       | string | The IKE version that is permitted for the VPN tunnels. Default: "IKEv2". | `IKEv2`                                                                                                                                           |
| {% endtab %}             |          |        |                                                                          |                                                                                                                                                   |

{% tab title="Request Header Parameters" %}
To make authenticated requests to the API, the following fields are mandatory in the request header:

| Header Parameters | Required | Type   | Description                                                                     |
| ----------------- | -------- | ------ | ------------------------------------------------------------------------------- |
| `Authorization`   | yes      | string | The Bearer token enables requests to authenticate using a JSON Web Token (JWT). |
| `Content-Type`    | yes      | string | Set this to `application/json`.                                                 |
| {% endtab %}      |          |        |                                                                                 |
| {% endtabs %}     |          |        |                                                                                 |

## Response

**200 Successful operation**

```json
{
  "id": "66a114c7-2ddd-5119-9ddf-5a789f5a5a44",
  "type": "ipsecgateway",
  "href": "/ipsecgateways/66a114c7-2ddd-5119-9ddf-5a789f5a5a44",
  "metadata": {
    "createdDate": "2020-12-10T13:37:50+01:00",
    "createdBy": "ionos:identity:::users/87f9a82e-b28d-49ed-9d04-fba2c0459cd3",
    "createdByUserId": "87f9a82e-b28d-49ed-9d04-fba2c0459cd3",
    "lastModifiedDate": "2020-12-11T13:37:50+01:00",
    "lastModifiedBy": "ionos:identity:::users/87f9a82e-b28d-49ed-9d04-fba2c0459cd3",
    "lastModifiedByUserId": "87f9a82e-b28d-49ed-9d04-fba2c0459cd3",
    "resourceURN": "ionos:<product>:<location>:<contract>:<resource-path>",
    "status": "AVAILABLE",
    "statusMessage": null
  },
  "properties": {
    "name": "My Company Gateway",
    "description": "This gateway connects site A to VDC X.",
    "gatewayIP": "81.173.1.2",
    "connections": [
      {
        "datacenterId": "5a029f4a-72e5-11ec-90d6-0242ac120003",
        "lanId": "2",
        "ipv4CIDR": "192.168.1.100/24",
        "ipv6CIDR": "2001:0db8:85a3::/24"
      }
    ],
    "version": "IKEv2"
  }
}
```

{% hint style="success" %}
**Result:** The IPSec Gateway is successfully updated or created.
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.ionos.com/cloud/~/revisions/AMiYziCllTKB2y2lmONY/network-services/vpn-gateway/api-how-tos/ensure-ipsec-gateways.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
